"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _shallowequal = _interopRequireDefault(require("shallowequal"));

var _pick = _interopRequireDefault(require("lodash/pick"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _Observable = _interopRequireDefault(require("./Observable"));

var _Watch = _interopRequireDefault(require("./Watch"));

var _default = function _default(options) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_React$Component) {
    (0, _inheritsLoose2.default)(_class, _React$Component);

    function _class(props) {
      var _this;

      _this = _React$Component.call(this, props) || this;
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "$children", void 0);
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "$data", void 0);
      (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "$watcher", void 0);
      var propsData = Object.create(null);
      (options.props || []).forEach(function (key) {
        propsData[key] = undefined;
      });
      var data = options.data ? options.data.call(_this.props) : {};
      var computed = null;

      if (options.computed) {
        computed = Object.create(null);
        Object.keys(options.computed).forEach(function (name) {
          computed[name] = options.computed[name];
        });
      } //绑定methods的this


      var methods = Object.create(null);

      if (options.methods) {
        Object.keys(options.methods).forEach(function (key) {
          methods[key] = options.methods[key].bind((0, _assertThisInitialized2.default)(_this));
        });
      }

      _this.$data = (0, _Observable.default)(Object.assign({}, propsData, methods, data), computed);

      if (options.watch) {
        Object.keys(options.watch).forEach(function (key) {
          _this.$watch(key, options.watch[key]);
        });
      }

      Object.keys(Object.assign({}, propsData, methods, computed, data)).forEach(function (key) {
        Object.defineProperty((0, _assertThisInitialized2.default)(_this), key, {
          get: function get() {
            return this.$data[key];
          },
          set: function set(v) {
            this.$data[key] = v;
          }
        });
      });

      _this.updateProps();

      _this.$watcher = new _Watch.default(_this.$data, function () {
        // strict mode
        // with (this.$data) {
        return options.render.call((0, _assertThisInitialized2.default)(_this), _react.default.createElement); // }
      }, (0, _debounce.default)(function (children) {
        _this.$children = children;

        _this.forceUpdate();
      })); // Init

      _this.$children = options.render.call((0, _assertThisInitialized2.default)(_this), _react.default.createElement);
      return _this;
    }

    var _proto = _class.prototype;

    _proto.updateProps = function updateProps(props) {
      var _this2 = this;

      if (props === void 0) {
        props = this.props;
      }

      Object.keys((0, _pick.default)(props, options.props || [])).forEach(function (key) {
        if (key === "props") {
          console.warn("The props property will replace React.Component#props");
        }

        _this2[key] = props[key];
      });
      this.children = props.children;
    };

    _proto.$watch = function $watch(exp, watchFn) {
      return this.$data.$watch(exp, watchFn.bind(this));
    };

    _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
      if (!(0, _shallowequal.default)((0, _pick.default)(this.props, options.props || []), (0, _pick.default)(nextProps, options.props || []))) {
        this.updateProps(nextProps);
        this.$children = options.render.call(this, _react.default.createElement);
        return true;
      }

      return false;
    };

    _proto.componentDidMount = function componentDidMount() {
      var _options$mounted;

      (_options$mounted = options.mounted) === null || _options$mounted === void 0 ? void 0 : _options$mounted.call(this);
    };

    _proto.componentWillUnmount = function componentWillUnmount() {
      var _options$destroyed;

      this.$watcher.clearDeps();
      (_options$destroyed = options.destroyed) === null || _options$destroyed === void 0 ? void 0 : _options$destroyed.call(this);
    };

    _proto.componentDidUpdate = function componentDidUpdate() {
      var _options$updated;

      (_options$updated = options.updated) === null || _options$updated === void 0 ? void 0 : _options$updated.call(this);
    };

    _proto.componentDidCatch = function componentDidCatch(error) {
      var _options$errorCapture;

      (_options$errorCapture = options.errorCaptured) === null || _options$errorCapture === void 0 ? void 0 : _options$errorCapture.call(options, error, this);

      if (options.renderError) {
        this.$children = options.renderError.call(this, _react.default.createElement, error);
      }
    };

    _proto.render = function render() {
      return this.$children;
    };

    _proto.$forceUpdate = function $forceUpdate() {
      this.forceUpdate();
    };

    _proto.$nextTick = function $nextTick(cb) {
      this.forceUpdate(cb);
    };

    _proto.$destroy = function $destroy() {
      if (this.props.$el) {
        _reactDom.default.unmountComponentAtNode(this.props.$el);

        this.$children = null;
      }
    };

    return _class;
  }(_react.default.Component), (0, _defineProperty2.default)(_class, "displayName", options.name), _temp;
};

exports.default = _default;