"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var Notify = /*#__PURE__*/function () {
  function Notify() {
    (0, _defineProperty2.default)(this, "listeners", []);
  }

  var _proto = Notify.prototype;

  _proto.sub = function sub(fn) {
    var _this = this;

    this.listeners.push(fn);
    return function () {
      var idx = _this.listeners.indexOf(fn);

      if (idx === -1) return;

      _this.listeners.splice(idx, 1);
    };
  };

  _proto.pub = function pub() {
    this.listeners.forEach(function (fn) {
      return fn();
    });
  };

  return Notify;
}();

exports.default = Notify;