"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports.default = Vue;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _Observable = _interopRequireDefault(require("./Observable"));

var _Watch = _interopRequireDefault(require("./Watch"));

var _Component = _interopRequireWildcard(require("./Component"));

Object.keys(_Component).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _Component[key];
    }
  });
});

function Vue(options) {
  var RootComponent = (0, _Component.default)(options);
  var el = options.el;

  if (typeof el === "string") {
    el = document.querySelector(el);
  }

  var props = Object.assign({}, options.propsData, {
    $el: el
  });
  return _reactDom.default.render( /*#__PURE__*/_react.default.createElement(RootComponent, props), el);
}

Vue.component = _Component.default;
Vue.observable = _Observable.default;

Vue.watch = function (expFn, watchFn, scope) {
  if (scope === void 0) {
    scope = null;
  }

  var watcher = new _Watch.default(scope, expFn, watchFn);
  return function () {
    return watcher.clearDeps();
  };
};