import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from "react";
import ReactDOM from "react-dom";
import shallowequal from "shallowequal";
import pick from "lodash/pick";
import debounce from "lodash/debounce";
import Observable from "./Observable";
import Watch from "./Watch";
export default (function (options) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_React$Component) {
    _inheritsLoose(_class, _React$Component);

    function _class(props) {
      var _this;

      _this = _React$Component.call(this, props) || this;

      _defineProperty(_assertThisInitialized(_this), "$children", void 0);

      _defineProperty(_assertThisInitialized(_this), "$data", void 0);

      _defineProperty(_assertThisInitialized(_this), "$watcher", void 0);

      var propsData = Object.create(null);
      (options.props || []).forEach(function (key) {
        propsData[key] = undefined;
      });
      var data = options.data ? options.data.call(_this.props) : {};
      var computed = null;

      if (options.computed) {
        computed = Object.create(null);
        Object.keys(options.computed).forEach(function (name) {
          computed[name] = options.computed[name];
        });
      } //绑定methods的this


      var methods = Object.create(null);

      if (options.methods) {
        Object.keys(options.methods).forEach(function (key) {
          methods[key] = options.methods[key].bind(_assertThisInitialized(_this));
        });
      }

      _this.$data = Observable(Object.assign({}, propsData, methods, data), computed);

      if (options.watch) {
        Object.keys(options.watch).forEach(function (key) {
          _this.$watch(key, options.watch[key]);
        });
      }

      Object.keys(Object.assign({}, propsData, methods, computed, data)).forEach(function (key) {
        Object.defineProperty(_assertThisInitialized(_this), key, {
          get: function get() {
            return this.$data[key];
          },
          set: function set(v) {
            this.$data[key] = v;
          }
        });
      });

      _this.updateProps();

      _this.$watcher = new Watch(_this.$data, function () {
        // strict mode
        // with (this.$data) {
        return options.render.call(_assertThisInitialized(_this), React.createElement); // }
      }, debounce(function (children) {
        _this.$children = children;

        _this.forceUpdate();
      })); // Init

      _this.$children = options.render.call(_assertThisInitialized(_this), React.createElement);
      return _this;
    }

    var _proto = _class.prototype;

    _proto.updateProps = function updateProps(props) {
      var _this2 = this;

      if (props === void 0) {
        props = this.props;
      }

      Object.keys(pick(props, options.props || [])).forEach(function (key) {
        if (key === "props") {
          console.warn("The props property will replace React.Component#props");
        }

        _this2[key] = props[key];
      });
      this.children = props.children;
    };

    _proto.$watch = function $watch(exp, watchFn) {
      return this.$data.$watch(exp, watchFn.bind(this));
    };

    _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
      if (!shallowequal(pick(this.props, options.props || []), pick(nextProps, options.props || []))) {
        this.updateProps(nextProps);
        this.$children = options.render.call(this, React.createElement);
        return true;
      }

      return false;
    };

    _proto.componentDidMount = function componentDidMount() {
      var _options$mounted;

      (_options$mounted = options.mounted) === null || _options$mounted === void 0 ? void 0 : _options$mounted.call(this);
    };

    _proto.componentWillUnmount = function componentWillUnmount() {
      var _options$destroyed;

      this.$watcher.clearDeps();
      (_options$destroyed = options.destroyed) === null || _options$destroyed === void 0 ? void 0 : _options$destroyed.call(this);
    };

    _proto.componentDidUpdate = function componentDidUpdate() {
      var _options$updated;

      (_options$updated = options.updated) === null || _options$updated === void 0 ? void 0 : _options$updated.call(this);
    };

    _proto.componentDidCatch = function componentDidCatch(error) {
      var _options$errorCapture;

      (_options$errorCapture = options.errorCaptured) === null || _options$errorCapture === void 0 ? void 0 : _options$errorCapture.call(options, error, this);

      if (options.renderError) {
        this.$children = options.renderError.call(this, React.createElement, error);
      }
    };

    _proto.render = function render() {
      return this.$children;
    };

    _proto.$forceUpdate = function $forceUpdate() {
      this.forceUpdate();
    };

    _proto.$nextTick = function $nextTick(cb) {
      this.forceUpdate(cb);
    };

    _proto.$destroy = function $destroy() {
      if (this.props.$el) {
        ReactDOM.unmountComponentAtNode(this.props.$el);
        this.$children = null;
      }
    };

    return _class;
  }(React.Component), _defineProperty(_class, "displayName", options.name), _temp;
});