import _defineProperty from "@babel/runtime/helpers/defineProperty";

var Notify = /*#__PURE__*/function () {
  function Notify() {
    _defineProperty(this, "listeners", []);
  }

  var _proto = Notify.prototype;

  _proto.sub = function sub(fn) {
    var _this = this;

    this.listeners.push(fn);
    return function () {
      var idx = _this.listeners.indexOf(fn);

      if (idx === -1) return;

      _this.listeners.splice(idx, 1);
    };
  };

  _proto.pub = function pub() {
    this.listeners.forEach(function (fn) {
      return fn();
    });
  };

  return Notify;
}();

export { Notify as default };