import React from "react";
import ReactDOM from "react-dom";
import Observable from "./Observable";
import Watch from "./Watch";
import Component from "./Component";
export * from "./Component";
export default function Vue(options) {
  var RootComponent = Component(options);
  var el = options.el;

  if (typeof el === "string") {
    el = document.querySelector(el);
  }

  var props = Object.assign({}, options.propsData, {
    $el: el
  });
  return ReactDOM.render( /*#__PURE__*/React.createElement(RootComponent, props), el);
}
Vue.component = Component;
Vue.observable = Observable;

Vue.watch = function (expFn, watchFn, scope) {
  if (scope === void 0) {
    scope = null;
  }

  var watcher = new Watch(scope, expFn, watchFn);
  return function () {
    return watcher.clearDeps();
  };
};