import _defineProperty from "@babel/runtime/helpers/defineProperty";
import objGet from "lodash/get";
import shallowequal from "shallowequal";
export var CurrentWatchDep = {
  current: null
};

var Watch = /*#__PURE__*/function () {
  function Watch(data, exp, fn) {
    _defineProperty(this, "last", void 0);

    _defineProperty(this, "_exp", void 0);

    _defineProperty(this, "exp", void 0);

    _defineProperty(this, "watchFn", void 0);

    _defineProperty(this, "deps", []);

    this.watchFn = fn;
    this._exp = exp;
    this.exp = typeof exp === "string" ? function () {
      return objGet(data, exp);
    } : function () {
      return exp.call(data);
    };
    var lastWatchDep = CurrentWatchDep.current;
    CurrentWatchDep.current = this;
    this.last = this.exp();
    CurrentWatchDep.current = lastWatchDep;
  }

  var _proto = Watch.prototype;

  _proto.clearDeps = function clearDeps() {
    this.deps.forEach(function (cb) {
      return cb();
    });
    this.deps = [];
  };

  _proto.addDep = function addDep(notify) {
    var _this = this;

    if (!notify.sub) console.log(notify, typeof notify, this._exp.toString());
    this.deps.push(notify.sub(function () {
      _this.check();
    }));
  };

  _proto.check = function check() {
    // 清空所有依赖，重新计算
    this.clearDeps();
    var lastWatchDep = CurrentWatchDep.current;
    CurrentWatchDep.current = this;
    var newValue = this.exp();
    CurrentWatchDep.current = lastWatchDep;
    var oldValue = this.last;

    if (!shallowequal(oldValue, newValue)) {
      this.last = newValue;
      this.watchFn(newValue, oldValue);
    }
  };

  return Watch;
}();

export { Watch as default };