import React from "react";
import Watch from "./Watch";
export interface ComponentOptions {
    props?: string[];
    name?: string;
    data?: () => Record<string, any>;
    methods?: Record<string, (e: Event) => void>;
    computed?: Record<string, () => any>;
    watch?: Record<string, (newValue: any, oldValue: any) => any>;
    render: (h: typeof React.createElement) => React.ReactNode;
    renderError?: (h: typeof React.createElement, error: Error) => React.ReactNode;
    mounted?: () => void;
    updated?: () => void;
    destroyed?: () => void;
    errorCaptured?: (e: Error, vm: React.ReactInstance) => void;
}
declare const _default: (options: ComponentOptions) => {
    new (props: {}): {
        [x: string]: any;
        $children: React.ReactNode;
        $data: Record<string, any>;
        $watcher: Watch;
        updateProps(props?: Readonly<{
            $el?: HTMLElement | undefined;
        }> & Readonly<{
            children?: React.ReactNode;
        }>): void;
        $watch(exp: string | (() => any), watchFn: (newValue: any, oldValue: any) => void): any;
        shouldComponentUpdate(nextProps: {}): boolean;
        componentDidMount(): void;
        componentWillUnmount(): void;
        componentDidUpdate(): void;
        componentDidCatch(error: Error): void;
        render(): React.ReactNode;
        $forceUpdate(): void;
        $nextTick(cb?: (() => void) | undefined): void;
        $destroy(): void;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<{
            $el?: HTMLElement | undefined;
        }>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<{
            $el?: HTMLElement | undefined;
        }> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        getSnapshotBeforeUpdate?(prevProps: Readonly<{
            $el?: HTMLElement | undefined;
        }>, prevState: Readonly<{}>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<{
            $el?: HTMLElement | undefined;
        }>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{
            $el?: HTMLElement | undefined;
        }>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<{
            $el?: HTMLElement | undefined;
        }>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<{
            $el?: HTMLElement | undefined;
        }>, nextState: Readonly<{}>, nextContext: any): void;
    };
    displayName: string | undefined;
    contextType?: React.Context<any> | undefined;
};
export default _default;
