import React from "react";
import Observable from "./Observable";
import Watch from "./Watch";
import { ComponentOptions } from "./Component";
export * from "./Component";
export interface Options extends ComponentOptions {
    el: HTMLElement | string;
    propsData?: Record<string, any>;
}
declare function Vue(options: Options): {
    [x: string]: any;
    $children: React.ReactNode;
    $data: Record<string, any>;
    $watcher: Watch;
    updateProps(props?: Readonly<{
        $el?: HTMLElement | undefined;
    }> & Readonly<{
        children?: React.ReactNode;
    }>): void;
    $watch(exp: string | (() => any), watchFn: (newValue: any, oldValue: any) => void): any;
    shouldComponentUpdate(nextProps: {}): boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(): void;
    componentDidCatch(error: Error): void;
    render(): React.ReactNode;
    $forceUpdate(): void;
    $nextTick(cb?: (() => void) | undefined): void;
    $destroy(): void;
    context: any;
    setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<{
        $el?: HTMLElement | undefined;
    }>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
    forceUpdate(callback?: (() => void) | undefined): void;
    readonly props: Readonly<{
        $el?: HTMLElement | undefined;
    }> & Readonly<{
        children?: React.ReactNode;
    }>;
    state: Readonly<{}>;
    refs: {
        [key: string]: React.ReactInstance;
    };
    getSnapshotBeforeUpdate?(prevProps: Readonly<{
        $el?: HTMLElement | undefined;
    }>, prevState: Readonly<{}>): any;
    componentWillMount?(): void;
    UNSAFE_componentWillMount?(): void;
    componentWillReceiveProps?(nextProps: Readonly<{
        $el?: HTMLElement | undefined;
    }>, nextContext: any): void;
    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{
        $el?: HTMLElement | undefined;
    }>, nextContext: any): void;
    componentWillUpdate?(nextProps: Readonly<{
        $el?: HTMLElement | undefined;
    }>, nextState: Readonly<{}>, nextContext: any): void;
    UNSAFE_componentWillUpdate?(nextProps: Readonly<{
        $el?: HTMLElement | undefined;
    }>, nextState: Readonly<{}>, nextContext: any): void;
};
declare namespace Vue {
    var component: (options: ComponentOptions) => {
        new (props: {}): {
            [x: string]: any;
            $children: React.ReactNode;
            $data: Record<string, any>;
            $watcher: Watch;
            updateProps(props?: Readonly<{
                $el?: HTMLElement | undefined;
            }> & Readonly<{
                children?: React.ReactNode;
            }>): void;
            $watch(exp: string | (() => any), watchFn: (newValue: any, oldValue: any) => void): any;
            shouldComponentUpdate(nextProps: {}): boolean;
            componentDidMount(): void;
            componentWillUnmount(): void;
            componentDidUpdate(): void;
            componentDidCatch(error: Error): void;
            render(): React.ReactNode;
            $forceUpdate(): void;
            $nextTick(cb?: (() => void) | undefined): void;
            $destroy(): void;
            context: any;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<{
                $el?: HTMLElement | undefined;
            }>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<{
                $el?: HTMLElement | undefined;
            }> & Readonly<{
                children?: React.ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: React.ReactInstance;
            };
            getSnapshotBeforeUpdate?(prevProps: Readonly<{
                $el?: HTMLElement | undefined;
            }>, prevState: Readonly<{}>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<{
                $el?: HTMLElement | undefined;
            }>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{
                $el?: HTMLElement | undefined;
            }>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<{
                $el?: HTMLElement | undefined;
            }>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<{
                $el?: HTMLElement | undefined;
            }>, nextState: Readonly<{}>, nextContext: any): void;
        };
        displayName: string | undefined;
        contextType?: React.Context<any> | undefined;
    };
    var observable: typeof Observable;
    var watch: (expFn: () => any, watchFn: (newValue: any, oldValue: any) => void, scope?: any) => () => void;
}
export default Vue;
